<template>
  <div class="tenant">
    <!-- <Banner /> -->
    <div class="content">
      <byTable
        :source="sourceList.data"
        :pagination="sourceList.pagination"
        :config="config"
        :loading="loading"
        highlight-current-row
        :selectConfig="selectConfig"
        :table-events="{
          //element talbe事件都能传
          select: select,
        }"
        :action-list="[]"
        @get-list="getList"
      >
        <template #slotName="{ item }">
          {{ item.createTime }}
        </template>
      </byTable>
    </div>
    <el-dialog
      title="异常跟进"
      v-model="dialogVisible"
      width="800"
      v-loading="loading"
    >
      <byForm
        :formConfig="formConfig"
        :formOption="formOption"
        v-model="formData.data"
        :rules="rules"
        ref="byform"
      >
      </byForm>
      <template #footer>
        <el-button @click="dialogVisible = false" size="large">取 消</el-button>
        <el-button
          type="primary"
          @click="submitForm('byform')"
          size="large"
          :loading="submitLoading"
        >
          确 定
        </el-button>
      </template>
    </el-dialog>

    <el-dialog title="跟进记录" v-model="dialogVisibleOne" width="500">
      <div>
        <el-timeline :reverse="false">
          <el-timeline-item
            placement="top"
            v-for="(activity, index) in activities"
            :key="index"
            :timestamp="activity.handleTime"
          >
            <div>
              跟进人：{{ activity.handleUserName }}
              <span>（{{ activity.status ? "已完成" : "处理中" }}）</span>
            </div>
            <div style="margin-top: 5px">跟进记录： {{ activity.explain }}</div>
          </el-timeline-item>
        </el-timeline>
      </div>
    </el-dialog>
  </div>
</template>
  
<script setup>
/* eslint-disable vue/no-unused-components */
import { ElMessage, ElMessageBox } from "element-plus";
import byTable from "@/components/byTable/index";
import byForm from "@/components/byForm/index";
import { computed, defineComponent, ref } from "vue";
import useUserStore from "@/store/modules/user";

const loading = ref(false);
const submitLoading = ref(false);
const sourceList = ref({
  data: [],
  pagination: {
    total: 3,
    pageNum: 1,
    pageSize: 10,
  },
});
let dialogVisible = ref(false);
let dialogVisibleOne = ref(false);

let roomDialogVisible = ref(false);
let modalType = ref("add");
let rules = ref({
  status: [
    { required: true, message: "请选择跟进结果", trigger: ["blur", "change"] },
  ],
  handleUser: [{ required: true, message: "请选择跟进人", trigger: "change" }],
  handleTime: [
    { required: true, message: "请选择跟进时间", trigger: "change" },
  ],
  processing: [
    { required: true, message: "请选择处理方式", trigger: "change" },
  ],
  explain: [{ required: true, message: "请输入处理说明", trigger: "blur" }],
});
const { proxy } = getCurrentInstance();
const selectConfig = reactive([
  {
    label: "异常来源",
    prop: "type",
    data: [],
  },
  {
    label: "处理状态",
    prop: "type",
    data: [],
  },
]);

const config = computed(() => {
  return [
    {
      attrs: {
        label: "异常来源",
        prop: "name",
      },
      render(type) {
        return proxy.dictDataEcho(type, warehouseType.value);
      },
    },
    {
      attrs: {
        label: "异常说明",
        prop: "type",
      },
    },
    {
      attrs: {
        label: "处理状态",
        prop: "name",
      },
      render(type) {
        return proxy.dictDataEcho(type, warehouseType.value);
      },
    },
    {
      attrs: {
        label: "最近操作人",
        prop: "keeperName",
      },
    },
    {
      attrs: {
        label: "最近操作时间",
        prop: "remark",
      },
    },

    {
      attrs: {
        label: "操作",
        width: "200",
        align: "right",
      },
      // 渲染 el-button，一般用在最后一列。
      renderHTML(row) {
        return [
          {
            attrs: {
              label: "跟进",
              type: "primary",
              text: true,
            },
            el: "button",
            click() {
              getDtl(row);
            },
          },
          {
            attrs: {
              label: "查看关联",
              type: "primary",
              text: true,
            },
            el: "button",
            click() {},
          },
          {
            attrs: {
              label: "跟进记录",
              type: "primary",
              text: true,
            },
            el: "button",
            click() {
              proxy
                .post("/abnormalDetails/page", {
                  abnormalInfoId: row.id,
                })
                .then((res) => {
                  if (res.rows.length > 0) {
                    activities.value = res.rows;
                    dialogVisibleOne.value = true;
                  } else
                    return ElMessage({
                      message: "暂无跟进记录！",
                      type: "info",
                    });
                });
            },
          },
        ];
      },
    },
  ];
});

let formData = reactive({
  data: {},
  treeData: [],
});
const formOption = reactive({
  inline: true,
  labelWidth: 100,
  itemWidth: 100,
  rules: [],
});
const byform = ref(null);
const treeData = ref([]);
const formConfig = reactive([
  {
    type: "radio",
    prop: "status",
    label: "跟进结果",
    required: true,
    border: true,
    data: [
      { label: "完成", value: "1" },
      { label: "跟进中", value: "0" },
    ],
  },

  {
    type: "select",
    prop: "handleUser",
    label: "跟进人",
    isLoad: {
      url: `/tenantUser/list?pageNum=1&pageSize=9999&tenantId=${
        useUserStore().user.tenantId
      }`,
      labelKey: "nickName",
      labelVal: "userId",
      method: "get",
      resUrl: "rows",
    },
  },
  {
    type: "select",
    prop: "nextHandleUser",
    label: "下一跟进人",
    isLoad: {
      url: `/tenantUser/list?pageNum=1&pageSize=9999&tenantId=${
        useUserStore().user.tenantId
      }`,
      labelKey: "nickName",
      labelVal: "userId",
      method: "get",
      resUrl: "rows",
    },
  },
  {
    type: "date",
    itemType: "datetime",
    prop: "handleTime",
    label: "跟进时间",
  },
  {
    type: "select",
    prop: "processing",
    label: "处理方式",
  },
  {
    type: "input",
    itemType: "textarea",
    prop: "explain",
    label: "处理说明",
  },
]);
const getList = async (req) => {
  sourceList.value.pagination = { ...sourceList.value.pagination, ...req };
  loading.value = true;
  proxy
    .post("/abnormalInfo/page", sourceList.value.pagination)
    .then((message) => {
      console.log(message);
      sourceList.value.data = message.rows;
      sourceList.value.data = [{}];
      sourceList.value.pagination.total = message.total;
      setTimeout(() => {
        loading.value = false;
      }, 200);
    });
};
const openModal = () => {
  dialogVisible.value = true;
  modalType.value = "add";
  formData.data = {};
};
const activities = ref([]);
const submitForm = () => {
  console.log(byform.value);
  byform.value.handleSubmit((valid) => {
    submitLoading.value = true;
    proxy.post("/abnormalDetails/" + modalType.value, formData.data).then(
      (res) => {
        ElMessage({
          message: modalType.value == "add" ? "添加成功" : "编辑成功",
          type: "success",
        });
        dialogVisible.value = false;
        submitLoading.value = false;
        getList();
      },
      (err) => (submitLoading.value = false)
    );
  });
};

const getDtl = (row) => {
  modalType.value = "add";
  formData.data.status = "0";
  dialogVisible.value = true;

  // proxy.post("/warehouse/detail", { id: row.id }).then((res) => {
  //   res.type = res.type + "";
  //   formData.data = res;
  //   console.log(formData);
  //   dialogVisible.value = true;
  // });
};
const warehouseType = ref([]);
const getDict = () => {
  // // 币种数据
  proxy
    .post("/dictTenantData/page", {
      pageNum: 1,
      pageSize: 999,
      tenantId: useUserStore().user.tenantId,
      dictCode: "warehouse_type",
    })
    .then((res) => {
      warehouseType.value = res.rows;
      selectConfig[0].data = res.rows.map((x) => ({
        label: x.dictValue,
        value: x.dictKey,
      }));
      formConfig[0].data = res.rows.map((x) => ({
        label: x.dictValue,
        value: x.dictKey,
      }));
    });
};
getList();
// getDict();
</script>
  
<style lang="scss" scoped>
.tenant {
  padding: 20px;
}
</style>